﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace YieldExample.Models
{
    public class ComplexRequest : IValidatableObject
    {
        [Required]
        public string SomeProperty { get; set; }

        [Required]
        public string SomeProperty2 { get; set; }

        public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
        {
            //custom validation of any properties here

            if (SomeProperty.Length < 10)
            {
                yield return new ValidationResult("SomeProperty: length validation triggered.", new[] { "SomeProperty" });
            }

            if (!SomeProperty2.StartsWith("z"))
            {
                yield return new ValidationResult("SomeProperty: does not start with 'z'.", new[] { "SomeProperty2" });
            }
        }
    }
}